Subject: Re: simple change to qdisc_restart()

From: Eric Lemoine <[email-masked]>
Date: Tue, 20 May 2003 13:24:02 +0200

> Let me explain a bit more.
> 
> I developped a kernel module that basically implements per-cpu kernel
> threads, each being bound to a particular cpu. I also modified the
> Myrinet NIC driver and firmware so that they implement per-cpu rx rings.
> 
> The NIC makes sure that packets of the same connection are always
> deposited in the same ring. Here's how it does it. For each incoming
> pkt, the NIC computes the index of the ring into which the packet must
> be placed [*], passes this index to the driver, and dmas the packet into
> the appropriate ring. The driver uses the ring index to wake up the
> appropriate kernel thread. Each kernel-thread behaves in a NAPI manner.

Oops. I forgot to mention that:

[*] Currently the NIC simply does ring_idx = IPsrc & (nr_rings-1).

-- 
Eric